PXML_HTTP Class Reference

`#include <pxml.h>`

Inheritance diagram for PXML_HTTP:

## Public Member Functions

| PXML_HTTP (int options=NoOptions, const char *noIndentElements=NULL)
bool | StartAutoReloadURL (const PURL &url, const PTimeInterval &timeout, const PTimeInterval &refreshTime, Options options=NoOptions)
bool | StopAutoReloadURL ()
PString | GetAutoReloadStatus ()
bool | AutoLoadURL ()
virtual void | OnAutoLoad (PBoolean ok)
bool | LoadURL (const PURL &url)
bool | LoadURL (const PURL &url, const PTimeInterval &timeout, Options options=NoOptions)
Public Member Functions inherited from PXML
| PXML (int options=NoOptions, const char *noIndentElements=NULL)
| PXML (const PString &data, int options=NoOptions, const char *noIndentElements=NULL)
| PXML (const PXML &xml)
| ~PXML ()
bool | IsLoaded () const
bool | IsDirty () const
bool | Load (const PString &data, Options options=NoOptions)
bool | LoadFile (const PFilePath &fn, Options options=NoOptions)
virtual void | OnLoaded ()
bool | Save (Options options=NoOptions)
bool | Save (PString &data, Options options=NoOptions)
bool | SaveFile (const PFilePath &fn, Options options=NoOptions)
void | RemoveAll ()
PBoolean | IsNoIndentElement (const PString &elementName) const
PString | AsString () const
void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...
PXMLElement * | GetElement (const PCaselessString &name, const PCaselessString &attr, const PString &attrval) const
PXMLElement * | GetElement (const PCaselessString &name, PINDEX idx=0) const
PXMLElement * | GetElement (PINDEX idx) const
PINDEX | GetNumElements () const
PXMLElement * | GetRootElement () const
PXMLElement * | SetRootElement (PXMLElement *p)
PXMLElement * | SetRootElement (const PString &documentType)
bool | RemoveElement (PINDEX idx)
PCaselessString | GetDocumentType () const
bool | Validate (const ValidationInfo *validator)
bool | ValidateElements (ValidationContext &context, PXMLElement *baseElement, const ValidationInfo *elements)
bool | ValidateElement (ValidationContext &context, PXMLElement *element, const ValidationInfo *elements)
bool | LoadAndValidate (const PString &body, const PXML::ValidationInfo *validator, PString &error, int options=NoOptions)
PString | GetErrorString () const
unsigned | GetErrorColumn () const
unsigned | GetErrorLine () const
PString | GetDocType () const
void | SetDocType (const PString &v)
PMutex & | GetMutex ()
Public Member Functions inherited from PXMLBase
| PXMLBase (int opts=NoOptions)
void | SetOptions (int opts)
int | GetOptions () const
void | SetMaxEntityLength (unsigned len)
unsigned | GetMaxEntityLength () const
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...

## Protected Member Functions

| PDECLARE_NOTIFIER (PTimer, PXML_HTTP, AutoReloadTimeout)
| PDECLARE_NOTIFIER (PThread, PXML_HTTP, AutoReloadThread)
Protected Member Functions inherited from PXML
void | Construct (int options, const char *noIndentElements)
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PTimer | autoLoadTimer
PURL | autoloadURL
PTimeInterval | autoLoadWaitTime
PMutex | autoLoadMutex
PString | autoLoadError
Protected Attributes inherited from PXML
PXMLElement * | rootElement
PMutex | rootMutex
bool | loadFromFile
PFilePath | loadFilename
PString | version
PString | encoding
StandAloneType | m_standAlone
PStringStream | m_errorString
unsigned | m_errorLine
unsigned | m_errorColumn
PSortedStringList | noIndentElements
PString | docType
PString | m_defaultNameSpace
Protected Attributes inherited from PXMLBase
int | m_options
unsigned | m_maxEntityLength

## Additional Inherited Members

Public Types inherited from PXML

enum

ValidationOp {
EndOfValidationList, DocType, ElementName, RequiredAttribute,
RequiredNonEmptyAttribute, RequiredAttributeWithValue, RequiredElement, Subtree,
RequiredAttributeWithValueMatching, RequiredElementWithBodyMatching, OptionalElement, OptionalAttribute,
OptionalNonEmptyAttribute, OptionalAttributeWithValue, OptionalAttributeWithValueMatching, OptionalElementWithBodyMatching,
SetDefaultNamespace, SetNamespace, RequiredAttributeWithValueMatchingEx = RequiredAttributeWithValueMatching + 0x8000, OptionalAttributeWithValueMatchingEx = OptionalAttributeWithValueMatching + 0x8000,
RequiredElementWithBodyMatchingEx = RequiredElementWithBodyMatching + 0x8000, OptionalElementWithBodyMatchingEx = OptionalElementWithBodyMatching + 0x8000
}

Public Types inherited from PXMLBase
enum | { DEFAULT_MAX_ENTITY_LENGTH = 4096 }
enum | Options { NoOptions = 0x0000, Indent = 0x0001, NewLineAfterElement = 0x0002, NoIgnoreWhiteSpace = 0x0004, CloseExtended = 0x0008, WithNS = 0x0010, FragmentOnly = 0x0020, AllOptions = 0xffff }
enum | StandAloneType { UninitialisedStandAlone = -2, UnknownStandAlone = -1, NotStandAlone, IsStandAlone }
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PXML
static PString | CreateStartTag (const PString &text)
static PString | CreateEndTag (const PString &text)
static PString | CreateTagNoData (const PString &text)
static PString | CreateTag (const PString &text, const PString &data)
static PString | EscapeSpecialChars (const PString &string)
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...

## Constructor & Destructor Documentation

## PXML_HTTP()

PXML_HTTP::PXML_HTTP | ( | int | options = `NoOptions`,
|  | const char * | noIndentElements = `NULL`
| ) |  |

## Member Function Documentation

## AutoLoadURL()

bool PXML_HTTP::AutoLoadURL | ( |  | ) |

## GetAutoReloadStatus()

PString PXML_HTTP::GetAutoReloadStatus | ( |  | ) |

inline

References PXMLBase::NoOptions, and PDECLARE_NOTIFIER.

## LoadURL() [1/2]

bool PXML_HTTP::LoadURL | ( | const PURL & | url | ) |

## LoadURL() [2/2]

bool PXML_HTTP::LoadURL | ( | const PURL & | url,
|  | const PTimeInterval & | timeout,
|  | Options | options = `NoOptions`
| ) |  |

## OnAutoLoad()

virtual void PXML_HTTP::OnAutoLoad | ( | PBoolean | ok | ) |

virtual

## PDECLARE_NOTIFIER() [1/2]

PXML_HTTP::PDECLARE_NOTIFIER | ( | PTimer | ,
|  | PXML_HTTP | ,
|  | AutoReloadTimeout |
| ) |  |

protected

## PDECLARE_NOTIFIER() [2/2]

PXML_HTTP::PDECLARE_NOTIFIER | ( | PThread | ,
|  | PXML_HTTP | ,
|  | AutoReloadThread |
| ) |  |

protected

## StartAutoReloadURL()

bool PXML_HTTP::StartAutoReloadURL | ( | const PURL & | url,
|  | const PTimeInterval & | timeout,
|  | const PTimeInterval & | refreshTime,
|  | Options | options = `NoOptions`
| ) |  |

## StopAutoReloadURL()

bool PXML_HTTP::StopAutoReloadURL | ( |  | ) |

## Member Data Documentation

## autoLoadError

PString PXML_HTTP::autoLoadError

protected

## autoLoadMutex

PMutex PXML_HTTP::autoLoadMutex

protected

## autoLoadTimer

PTimer PXML_HTTP::autoLoadTimer

protected

## autoloadURL

PURL PXML_HTTP::autoloadURL

protected

## autoLoadWaitTime

PTimeInterval PXML_HTTP::autoLoadWaitTime

protected

The documentation for this class was generated from the following file:

- pxml.h